"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useDynamicImport = void 0;
var _react = require("react");
function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;
    var cache = new WeakMap();
    _getRequireWildcardCache = function() {
        return cache;
    };
    return cache;
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
const useDynamicImport = (name)=>{
    const [props, setProps] = (0, _react).useState(null);
    (0, _react).useEffect(()=>{
        let resolved = false;
        Promise.resolve(`@docgen/${name}.json`).then(function(s) {
            return _interopRequireWildcard(require(s));
        }).then((props)=>{
            if (!resolved) {
                resolved = true;
                setProps(props.default);
            }
        }).catch(console.error);
        return ()=>{
            resolved = true;
        };
    }, [
        name
    ]);
    return props;
};
exports.useDynamicImport = useDynamicImport;

//# sourceMappingURL=useDynamicImport.js.map